# データの作成
dat <- matrix(c(392,55,33,76,38,9,31,7,115),ncol=3,nrow=3,by=T)

# emアルゴリズム
# dat は 3 * 3の分割表
em.step <- function(dat){
  old.param <- matrix(1/4,ncol=2,nrow=2)
  new.param <- old.param + 0.01
  # 以下は最終段階で取る
  count <- 1
  lik <- NULL
  lik[1] <- log.likelihood(old.param,dat)
  # dat から初期値を設定する
  # EM アルゴリズムのiteration
  while( max(abs(old.param - new.param)) >10^(-6) ){
    # t <- t+1
    old.param <- new.param
    # E-step
    tmp.dat <- matrix(0,ncol=2,nrow=2)
    for( index in 1:2 ){
      for( subindex in 1:2 ){
        tmp.dat[index,subindex] <-
          dat[index,subindex] +
            dat[3,subindex] * old.param[index,subindex] /
              sum(old.param[,subindex]) +
                dat[index,3] *  old.param[index,subindex] /
                  sum(old.param[index,]) 
      }
    }
    # M-step
    n <- sum(dat)-dat[3,3]
    for( index in 1:2 ){
      for( subindex in 1:2 ){
        new.param[index,subindex] <- tmp.dat[index,subindex]/n
      }
    }
    # 尤度の計算
    count <- count + 1
    lik[count] <- log.likelihood(new.param,dat)
  }
  return(list(param=new.param,lik=lik,count=count))
}

# 対数尤度
log.likelihood <- function(param,dat){
  tmp <- sum(dat[1:2,1:2] * log(param)) +
    dat[3,1] * log(sum(param[,1])) + dat[3,2] * log(sum(param[,2])) + 
      dat[1,3] * log(sum(param[1,])) + dat[2,3] * log(sum(param[2,])) 
  return(tmp)
}



