# パラメータのEMアルゴリズムによる推定
source("emexample1.R")
tmp.dat <- read.csv("apple.csv",header=F)
tmp.dat <- as.matrix(tmp.dat)
result <- em.step(tmp.dat[,3:4],tmp.dat[,1:2])

# データ行列をD，欠測指標の行列をRとする
D <- tmp.dat[,1:2]
R <- 1 - tmp.dat[,3:4] #以下のRは通常のRの定義(1で観測，0で欠測)なので変換

# Little の検定を行なう(d2が統計量)
diff1 <- apply(D[R[,2]>0,],2,mean)-result$Heikin
diff2 <- apply(D[R[,2]==0,],2,mean)[1]-result$Heikin[1]
d2 <- sum(R[,2]>0) * t(diff1) %*% solve((18/17)*result$Bunsan) %*% diff1 +
       sum(R[,2]==0) * t(diff2) %*% solve((18/17)*result$Bunsan[1,1]) %*% diff2
