###  多変量正規分布のためのem algorithm

# R は欠測指標行列
# Y はデータ行列(欠測値の部分は何でも良いから埋める)
em.step <- function(R,Y){
  # サンプルサイズ
  n <- dim(Y)[1] 
  # パラメタ値
  new.mu <- apply((1-R)*Y,2,mean)
  old.mu <- new.mu + 1
  new.Sigma <- t((1-R)*Y)%*%((1-R)*Y)/n
  old.Sigma <- new.Sigma + 1
  # 繰り返し回数と尤度
  count <- 0 
  lik <- NULL
  lik[1] <- log.likelihood(old.mu,old.Sigma,R,Y)
  while( max(abs(c(old.mu - new.mu, old.Sigma - new.Sigma))) >10^(-6) ){
    # t <- t+1
    old.mu <- new.mu 
    old.Sigma <- new.Sigma 
    # E-step
    Y[R[,2]==1,2] <- old.mu[2] + (old.Sigma[2,1] / old.Sigma[1,1]) * 
    		    	      			(Y[R[,2]==1,1] - old.mu[1])
    # M-step
    new.mu <- t(Y)  %*% rep(1,n)/n
    new.Sigma <- t(Y) %*% Y /n - new.mu %*% t(new.mu) + 
    	      t(R) %*% R * (old.Sigma[2,2] - old.Sigma[1,2]^2/old.Sigma[1,1])/n
    # 回数の加算
    count <- count + 1
    # 尤度の計算
    lik[count] <- log.likelihood(new.mu,new.Sigma,R,Y)
  }
  return(list(Heikin=new.mu,Bunsan=new.Sigma,lik=lik,count=count))
}


# 尤度を計算する 
library(mvtnorm)
log.likelihood <- function(mu,Sigma,R,Y){
  lf <- 0 
  for ( index in 1:dim(Y)[1] ){
    lf <- lf + (1-R[index,2])* dmvnorm(Y[index,],mu,Sigma,log=TRUE) +  
       	       R[index,2] * dnorm(Y[index,1],mu[1],Sigma[1,1],log=TRUE)
  }
  return(lf)
}

